<template>
  <div>
    <div class="padding-top margin-0-4">
      <el-header style="height: auto" class="padding-0">
        <ReturnButton
          :spanTitle="2"
          title="Regresar"
          style="margin-bottom: 35px;"
          @clickEvent="returnPage"
        />
        <!-- Buscador -->
        <el-row>
          <el-col :span="4" :offset="10">
            <el-input
              placeholder="Código"
              prefix-icon="el-icon-search"
              v-model.trim="codeSearch"
              @keyup.enter.native="findCodeProgram"
              clearable
            ></el-input>
          </el-col>
          <el-col :span="9" :offset="1">
            <el-autocomplete
              v-model="textSearch"
              style="width: 100%;"
              :fetch-suggestions="querySearch"
              placeholder="Nombre del programa"
              :trigger-on-focus="false"
              @select="handleSelect"
            >
              <i class="el-icon-search el-input__icon" slot="prefix"></i>
              <template slot-scope="props">
                <div>{{ props.item.programTitle }}</div>
              </template>
            </el-autocomplete>
          </el-col>
        </el-row>
        <!-- Título del programa -->
        <el-col :span="24">
          <div
            class="titleSection"
          >PROGRAMACIÓN {{typeChannel}} - {{ programObj.programTitle }} ({{programObj.codProgram}})</div>
        </el-col>
        <!-- Fecha y botones -->
        <el-row>
          <el-col :span="7">
            <p style="margin-top: 0.6rem;">{{ dateString }}</p>
          </el-col>
          <el-col :span="7">
            <el-date-picker
              class="date-head"
              v-model="dateSearch"
              type="date"
              format="dd/MM/yyyy"
              value-format="timestamp"
              placeholder="Escoja una semana"
              @input="setWeek"
            ></el-date-picker>
          </el-col>

          <el-col :span="6" class="text-end"></el-col>
          <el-col :span="2" :offset="7">
            <el-button
              v-on:click="programObjectInfo('programGridPreliminary', objGridInfo)"
              type="primary"
              :disabled="isWeekAprovedFlag"
            >PROGRAMAR</el-button>
          </el-col>
        </el-row>
      </el-header>
      <el-main style="padding: 0; margin: 1rem 0 3rem">
        <br />
        <div class="scheduleProgramming">
          <div class="scheduleDay-border" style="height: 100%;"></div>
          <div class="scheduleDay scheduleDay-border">
            Lunes
            <span class="textCollapse">{{addingZerosToTheDay(firstDay)}}</span>
          </div>
          <div class="scheduleDay scheduleDay-border">
            Martes
            <span class="textCollapse">{{addingZerosToTheDay(secondDay)}}</span>
          </div>
          <div class="scheduleDay scheduleDay-border">
            Miércoles
            <span class="textCollapse">{{addingZerosToTheDay(thirdDay)}}</span>
          </div>
          <div class="scheduleDay scheduleDay-border">
            Jueves
            <span class="textCollapse">{{addingZerosToTheDay(fourthDay)}}</span>
          </div>
          <div class="scheduleDay scheduleDay-border">
            Viernes
            <span class="textCollapse">{{addingZerosToTheDay(fifthDay)}}</span>
          </div>
          <div class="scheduleDay scheduleDay-border">
            Sábado
            <span class="textCollapse">{{addingZerosToTheDay(sixthDay)}}</span>
          </div>
          <div class="scheduleDay">
            Domingo
            <span class="textCollapse">{{addingZerosToTheDay(lastDay)}}</span>
          </div>
        </div>

        <div class="scheduleData" ref="scheduleData">
          <div
            style="grid-area: 1 / span 1"
            class="columColor scheduleCellData__border-bottom schedule__border-right scheduleCellData__border-top"
          >Inicio</div>
          <div
            style="grid-area: 2 / span 1"
            class="columColor scheduleCellData__border-bottom schedule__border-right scheduleCellData__border-top"
          >Final</div>
          <div
            style="grid-area: 3 / span 1"
            class="columColor scheduleCellData__border-bottom schedule__border-right scheduleCellData__border-top"
          >Material</div>
          <div
            style="grid-area: 4 / span 1"
            class="columColor scheduleCellData__border-bottom schedule__border-right scheduleCellData__border-top"
          >Capítulo</div>
          <div
            style="grid-area: 5 / span 1"
            class="columColor scheduleCellData__border-bottom schedule__border-right scheduleCellData__border-top"
          >Estado</div>
          <div
            style="grid-area: 6 / span 1"
            class="columColor scheduleCellData__border-bottom schedule__border-right scheduleCellData__border-top"
          >Tipo de Contenido</div>
        </div>
        <br />
      </el-main>
      <!--ALERTA -->
      <AppModal
        :show-dialog.sync="modalOfChapterValidation"
        v-if="modalOfChapterValidation"
        nameClass="dialog-red"
        :rutImg="require(`../../../assets/images/alerta.svg`)"
        sizeImg="80%"
        :parrafo="textModal"
      ></AppModal>
    </div>
  </div>
</template>

<script>
// import AppNav from '@/components/AppNav.vue'
import ReturnButton from '@/components/ReturnButton.vue'
import { mapState } from 'vuex'
import { modifyText } from '@/utils/modifyText.js'
import { getFirstDay } from '@/utils/calculateTime.js'
import {HTTP} from '@/main.js'
import { calculateHour } from '@/utils/calculateTimePrograms.js'
import { months } from '@/enums.js'
import AppModal from '@/components/AppModal.vue'
import { convertFirstWordTouperCase } from '@/utils/calculateTime.js'
import moment from 'moment'
moment.locale('es');

export default {
  components: { ReturnButton, AppModal },
  data () {
    let typeChannel = this.$route.params.type || 'AMÉRICA TV'
    return {        
      dateSearch: this.getDateEnglish(),
      modalOfChapterValidation: false,
      textModal: null,
      textSearch: '',
      programObj: '', 
      codeSearch: '',
      gridObj: {},
      firstDayOfWeek: '',
      firstDayTable: 'Lunes',
      secondDayTable: 'Martes',
      thirdDayTable: 'Miercoles',
      fourthDayTable: 'Jueves',
      fifthDayTable: 'Viernes',
      sixthDayTable: 'Sabado',
      lastDayTable: 'Domingo',
      firstDay: '',
      secondDay: '',
      thirdDay: '',
      fourthDay: '',
      fifthDay: '',
      sixthDay: '',
      lastDay: '',
      month: '',
      year: '',
      dateString: '',
      arrOfDays: [],
      arrProgram:[],
      firstDayYeih: '',
      arrByDays:[],
      completeDateArr: [],
      cardsData: [0,0,0,0,0,0,0],
      typeChannel: typeChannel,
      codeProgramSelected: '',
      startDate: '',
      endDate: '',
      month2: '',
      year2: '',
      scheduleDinamicData: '',
      durationCortes: '',
      isWeekAprovedFlag: false,
      gridData:null,
      objGridInfo:{}
    }
  },
  sockets:{
    updateGridPreliminary(data){
      this.isWeekAproved()
      this.getWeekDays()
		}
  },
  computed: {
    ...mapState({
      getDataWeek: state => state.allGrid
    }),
    seeElements() {
      const data = [
        this.codeProgramSelected
      ].join()
      return data
    }
  },
  async created() {
    this.setDay()
    await this.programSaved()
    this.setWeek()
    this.getWeekDays()  
  },
  mounted(){
      if(sessionStorage.getItem('programa-parrilla-peliminar')){
      this.programObj = JSON.parse(sessionStorage.getItem('programa-parrilla-peliminar'));
      this.codeProgramSelected = this.programObj.codProgram
    }
  },
  methods: {
    setDay() {
      let data = this.$route.params.day
      if(data && data !== ''){
        this.dateSearch = data
      }
    },
    setWeek () {
      if (this.dateSearch === '' || this.dateSearch === null) { 
        
        this.firstDayOfWeek = getFirstDay(new Date())
        this.startDate = getFirstDay(new Date())
        this.firstDay = moment(this.firstDayOfWeek).format('D')
        this.secondDay = moment(this.firstDayOfWeek).add(1, 'days').format('D')
        this.thirdDay = moment(this.firstDayOfWeek).add(2, 'days').format('D')
        this.fourthDay = moment(this.firstDayOfWeek).add(3, 'days').format('D')
        this.fifthDay = moment(this.firstDayOfWeek).add(4, 'days').format('D')
        this.sixthDay = moment(this.firstDayOfWeek).add(5, 'days').format('D')
        this.lastDay = moment(this.firstDayOfWeek).add(6, 'days').format('D')
        this.endDate = moment(this.firstDayOfWeek).add(6, 'days')._d
        this.month = convertFirstWordTouperCase(moment(this.firstDayOfWeek).format('MMMM'))
        this.month2 = convertFirstWordTouperCase(moment(this.endDate).format('MMMM'))
        this.year = moment(this.firstDayOfWeek).format('YYYY')
        this.year2 = moment(this.endDate).format('YYYY')
      } else {
        this.firstDayOfWeek = getFirstDay(new Date(this.dateSearch));
        this.startDate = getFirstDay(new Date(this.dateSearch))
        this.firstDay = moment(this.firstDayOfWeek).format('D')
        this.secondDay = moment(this.firstDayOfWeek).add(1, 'days').format('D')
        this.thirdDay = moment(this.firstDayOfWeek).add(2, 'days').format('D')
        this.fourthDay = moment(this.firstDayOfWeek).add(3, 'days').format('D')
        this.fifthDay = moment(this.firstDayOfWeek).add(4, 'days').format('D')
        this.sixthDay = moment(this.firstDayOfWeek).add(5, 'days').format('D')
        this.lastDay = moment(this.firstDayOfWeek).add(6, 'days').format('D')
        this.endDate = moment(this.firstDayOfWeek).add(6, 'days')._d
        this.month = convertFirstWordTouperCase(moment(this.firstDayOfWeek).format('MMMM'))
        this.month2 = convertFirstWordTouperCase(moment(this.endDate).format('MMMM'))
        this.year = moment(this.firstDayOfWeek).format('YYYY')
        this.year2 = moment(this.endDate).format('YYYY')
      }

      if (this.month == this.month2 && this.year == this.year2  ) {
        this.dateString = `Semana del ${this.firstDay} al ${this.lastDay} de ${this.month} del ${this.year}`
      }
      else if (this.month !== this.month2 && this.year == this.year2 ) {
        this.dateString = `Semana del ${this.firstDay} de ${this.month} al ${this.lastDay} de ${this.month2} del ${this.year}`
      }
      else if (this.month !== this.month2 && this.year !== this.year2) {
          this.dateString = `Semana del ${this.firstDay} de ${this.month} del ${this.year} al ${this.lastDay} de ${this.month2} del ${this.year2}`
      }
      if(this.programObj.programTitle) {
        // this.functionone()
        
      }
      this.filterWeek()
    },
    async filterWeek() {
      const type = 'preliminary';
      let dataSelect = []
      await this.isWeekAproved()
      console.log(this.gridData, 'gridData')
      if(this.gridData!=null){
        dataSelect = this.gridData.preliminaryPrograms.filter(
          el=> el.refProgram && el.refProgram.codProgram === this.codeProgramSelected
        )
        const {_id = "There is no id",
               week = "Week not found", 
               programs = [], 
               preliminaryPrograms = [] } = this.gridData
        let fullGridData = {_id,programs,preliminaryPrograms,week}
        this.objGridInfo = {
          _id,
          count: dataSelect.length,
          fullGrid: fullGridData,
          gridMatch: dataSelect,
          weekDate: week    
        }
      }else{
        this.objGridInfo = {
          count: 0,
          fullGrid: Array(0),
          gridMatch: Array(0),
          weekDate: "Week not found",
          _id: "There is no id"
        }
      }
      console.log(this.objGridInfo._id, 'filterWeek')
    },
    async findCodeProgram () {
      const channel = localStorage.getItem('channelTransmition');
      let response = await HTTP.post('programs/filterProgram',{code:this.codeSearch,channel});
      if ( response.data.docs.length == 0 ) {
        this.textModal = `<p> No se <span class="text-red text-bold"> ENCONTRÓ </span> ningún programa con este código <strong> ${this.codeSearch}</strong> </p>`
        this.modalOfChapterValidation = true 
        this.codeSearch = ''
      }
      else {
        // if(response.data.docs.length==0) return;
        this.programObj = response.data.docs[0]
        this.codeProgramSelected = response.data.docs[0].codProgram   
      }
      this.filterWeek()
    },
    async programSaved() {
      const lastProgram = JSON.parse(localStorage.getItem('lastProgramActualizate'));
      console.log("lastProgram", lastProgram)
      let channelTransmission = localStorage.getItem('channelTransmition');

      channelTransmission = channelTransmission == 'AMÉRICA TV' ? 'América TV' : 'América Next';

      if (lastProgram){
        if(lastProgram.checkedChanels.length > 0){
          let isIncluded = false
          lastProgram.checkedChanels.map((mat)=>{
            if(mat.toLowerCase() == channelTransmission.toLowerCase()) {
              isIncluded = true
              this.codeProgramSelected = lastProgram.codProgram
              this.programObj = lastProgram
            }
          })
          if (isIncluded == false){
            await this.getItemsByChannelTransmission(channelTransmission)
          }
        } else {
          if(!sessionStorage.getItem('programa-parrilla')){
            this.codeProgramSelected = lastProgram.codProgram          
            this.programObj = lastProgram
          }          
        }
      } else {
         await this.getItemsByChannelTransmission(channelTransmission)
      }
    },
    async getItemsByChannelTransmission(channelTransmission) {
      const response = await HTTP.post('programs/filterProgram',{channel:channelTransmission});
      const programs = response.data.docs;
      this.codeProgramSelected = programs.length > 0 ? programs[0].codProgram : ''
      this.programObj = programs[0] ? programs[0] : {}
    },
    addingZerosToTheDay(day){
			if(String(day).length < 2){
				day = '0'+ day
			}
			return day
    },
    fillingProgramTable(data) {
      // REMOVER ELEMENTOS EXISTENTES
      const arrOfClasses = ['newDiv', 'newDivEmpty']
      this.removePreviousDivs(arrOfClasses)
      // RECORRER NUEVA DATA Y CREAR DIVS
      let newData = data.filter(item => item.aItems !== "Duraccion")
      newData.map((fila, i)=>{
        const dataLength = data.length
        const keys = Object.keys(fila)
        if(fila.aItems == 'Inicio' || fila.aItems == 'Final' || fila.aItems == 'Capítulo' || fila.aItems == 'Estado'){
          keys.map((key, index)=>{
            if(index > 0){
              let objOfDay = this.arrByDays[index-1]
              const validateContent = fila[key] !== '' && fila[key] !== undefined
              const validateContentAfter = fila[keys[index+1]] !== '' && fila[keys[index+1]] !== undefined
              this.createNewDiv(fila, key, validateContent, validateContentAfter, objOfDay)
            }
          })
        }
        if(fila.aItems == 'Material' || fila.aItems == 'N° de Cortes' || fila.aItems == 'Duración Artística'
            || fila.aItems == 'Clasificación' || fila.aItems == 'Género' || fila.aItems == 'Tipo' || fila.aItems == 'Señales'){
          let arr = []
          keys.map((key, index)=>{
            if(index > 0){
              let objOfDay = (index>1)?this.arrByDays[index-2]:0
              let classVerify = (objOfDay!== 0)?this.validateCrossover(objOfDay, '', 'redText'):''
              
              // DEBE VERIFICAR SI EL ANTERIOR ES IGUAL A ESTE
              if(fila[key] == fila[keys[index-1]]){
                const isTrue = (fila[keys[index+1]] !== '') && (index !==  keys.length - 1)
                this.generatingDivs(fila, key, index, keys, arr, isTrue, i, dataLength, classVerify)
              } else {
                const classToAdd = ['newDiv', 'newDiv border-b-0']
                this.createColspanDiv(arr, fila, keys, classToAdd, i, dataLength, classVerify, index)
                arr = []
                const isTrue = (fila[keys[index+1]] !== '') && (index !==  keys.length - 1)
                this.generatingDivs(fila, key, index, keys, arr, isTrue, i, dataLength, classVerify)
              }
            }
          })
        }
        
      })
    },
    /*Methods to Fill Table Structure */
    removePreviousDivs(arr){
      arr.map((el)=>{
        document.querySelectorAll('.'+el).forEach(function(a){
          a.remove()
        })
      })
    },
    createNewDiv(fila, prop, boolean, booleanAfter, objOfDay) {
      const divToAdd = document.createElement('div')
      if(boolean){
        let holis = ( objOfDay !== 0 ) ? this.validateCrossover( objOfDay, '' , 'redText' ) : ''
        divToAdd.className = (prop == 'hLastDayStart')? `newDiv border-r-0 ${holis}`:`newDiv ${holis}`
      } else {
        divToAdd.className = (booleanAfter)?'newDivEmpty schedule__border-right': 'newDivEmpty'
      }
      divToAdd.innerHTML = fila[prop]
      this.$refs.scheduleData.appendChild(divToAdd)
    },
    createColspanDiv(arr, fila, keys, newClass, i, dataLength, classVerify, index) {
      let days = ['Lunes', 'Martes', 'Miercoles', 'Jueves', 'Viernes', 'Sabado', 'Domingo']
      if(arr.length > 0) {
        const newDiv = document.createElement('div')
        if(fila.aItems == 'N° de Cortes' &&  fila[keys[arr[0]]] !== 'Sin Cortes') {
          const containerT = document.createElement('div')
          let span = document.createElement('span')
          span.className = 'tooltiptext'
          if ( arr.length > 1 ) {
            let hola = ''
            arr.map((el, i, array) => {
              hola += `<span class="text-orange text-bold"> ${days[array[i] - 1 ]}: </span> <br>`
              let mam = this.arrProgram
              if( i > 0) {
                if ( mam[5][keys[el]]  !== hola ) {
                  hola += mam[5][keys[el]]  + ' <br> ' 
                }
              }
              else {
                hola += mam[5][keys[el]] + ' <br>' 
              }        
            })
            span.innerHTML = hola
          }
          else {
            let text = `<span class="text-orange text-bold"> ${days[arr[0] - 1 ]}: </span> <br> ${ this.arrProgram[5][keys[arr[0]]] }`
            span.innerHTML = text
          }
          
          containerT.innerHTML = fila[keys[arr[0]]]
          containerT.className = 'tooltip'
          containerT.appendChild(span)
          newDiv.appendChild(containerT)
        }
        else {
          newDiv.innerHTML = fila[keys[arr[0]]]
        }
   
        let data = dataLength
        let classAdd = ''
        if(arr.includes(index-1)){
          classAdd = classVerify
        }
        if(i == (data -1)){
          classAdd = classAdd + ' '+ newClass[1]
        } else {
          classAdd = classAdd + ' '+ newClass[0]
        }
        newDiv.className = classAdd
        newDiv.style.gridArea = `${i+1} / ${arr[0] +1} / ${i+2} / span ${arr.length}`
        this.$refs.scheduleData.appendChild(newDiv)
      }
    },
    createDivEmpty(isTrue) {
      const newDiv = document.createElement('div')
      newDiv.className = (isTrue)?'newDivEmpty schedule__border-right':'newDivEmpty'
      this.$refs.scheduleData.appendChild(newDiv)
    },
    generatingDivs(fila, key, index, keys, arr, isTrue, i, data, classVerify){
      if(fila[key] !== ''){
        arr.push(index)
        if(index == (keys.length -1)){
          let classToAdd = ['newDiv border-r-0', 'newDiv border-r-0 border-b-0']
          
          const dataLength = data
          this.createColspanDiv(arr, fila, keys, classToAdd, i, dataLength, classVerify, index)
          arr = []
        }
      } else {
        this.createDivEmpty(isTrue)
      }
    },
    /*------ */
    returnPage(value) {
      // if(value) {
        this.$router.push({ name: 'views', params: {subTitle: this.typeChannel} })
      // }
    },
    headerRowClass({row, rowIndex}) {
      if (rowIndex === 0) {
        return 'orangeHead';
      } 
    },
    getDateEnglish() {
      let completeObjectParse = JSON.parse(this.$localStorage.get("programedProgram"));
      let miliseconds;
      if (completeObjectParse === '' || completeObjectParse == null ) {
        miliseconds = new Date()
      } else {
        let dateString = new Date(completeObjectParse.year, completeObjectParse.month, completeObjectParse.day)
        miliseconds = dateString.getTime();
      }
      return miliseconds
    },
    getWeekDays() {
      this.cardsData = [0,0,0,0,0,0,0]
      this.durationCortes = []
      let weekDays = [this.firstDay.toString(), this.secondDay.toString(), this.thirdDay.toString(), this.fourthDay.toString(), this.fifthDay.toString(), this.sixthDay.toString(), this.lastDay.toString()]
        this.firstDayTable = `Lunes ${weekDays[0]}`
        this.secondDayTable = `Martes ${weekDays[1]}`
        this.thirdDayTable = `Miércoles ${weekDays[2]}`
        this.fourthDayTable = `Jueves ${weekDays[3]}`
        this.fifthDayTable = `Viernes ${weekDays[4]}`
        this.sixthDayTable = `Sábado ${weekDays[5]}`
        this.lastDayTable = `Domingo ${weekDays[6]}`
        this.$localStorage.set('programedProgram', JSON.stringify(''))
        this.dataGetter(this.programObj, weekDays, this.objGridInfo)
    },
    getFullDateOfTransmissionsDays () {
      // METODO PARA GENERAR LAS FECHAS COMPLETAS DE LOS DIAS DE TRANSMISION
      let arrTransmissionDays = this.programObj.transmissionDays
      let day
      let arrCompleteDays = []
      for (let x = 0; x < arrTransmissionDays.length; x++) {
        switch (modifyText(arrTransmissionDays[x])) {
          case 'lunes':
            day = this.firstDayOfWeek
            break;
          case 'martes':
            day = new Date(this.firstDayOfWeek.getTime() + (24*60*60*1000))
            break;
          case 'miercoles':
            day = new Date(this.firstDayOfWeek.getTime() + (24*60*60*1000)*2)
            break;
          case 'jueves':
            day = new Date(this.firstDayOfWeek.getTime() + (24*60*60*1000)*3)
            break;
          case 'viernes':
            day = new Date(this.firstDayOfWeek.getTime() + (24*60*60*1000)*4)
            break;
          case 'sabado':
            day = new Date(this.firstDayOfWeek.getTime() + (24*60*60*1000)*5)
            break;
          case 'domingo':
            day = new Date(this.firstDayOfWeek.getTime() + (24*60*60*1000)*6)
            break;
        }
               let dateTime = moment(day)
        let mes = convertFirstWordTouperCase(dateTime.format('MMMM'))
        let dia = convertFirstWordTouperCase(dateTime.format('dddd')) 
        let numberDay = dateTime.format('D')
        let anio = dateTime.format('YYYY')
        let space = ' '

        let dateSentence = dia + space + numberDay  + space +   'de' + space + mes + space + 'del' + space + anio
        arrCompleteDays.push(dateSentence);
      }
      // console.log(arrCompleteDays, 'arrCompleteDays')
      return arrCompleteDays
    },
    // METODO PARA VALIDAR CRUCE DE PROGRAMAS EN LA DATA
    verifyProgramCrossover(obj, isEmpty, arrItems, element, textToShow){
      if(obj !== 0){
        if(isEmpty) {
          arrItems[arrItems.length -1][ element ] = '';
        } else {
          // ACA VA EL METODO DE LA VALIDACION DE CHECK CROSSES
          arrItems[ arrItems.length -1 ][ element ] = this.validateCrossover(obj, textToShow)
          if ( arrItems.length == 7 ) {
             arrItems[5][element ] = this.durationCortes
          }
        }
      } else {
        arrItems[arrItems.length -1][ element ] = '';
      }
    },
    // METODO PARA VERIFICAR SI EL PROGRAMA TIENE CRUCE DE HORARIO
    validateCrossover(obj, value1, value2){
      let arrCheckCrosses = obj.arrCheckCrosses
      let lastValue = ''
      if(arrCheckCrosses !== undefined && arrCheckCrosses.length > 0){
        arrCheckCrosses.map((crossObject)=>{
          if(crossObject.title == obj.programGridTitle){
            crossObject.completeDaysCrushed.map((dayWithCross)=>{
              if(dayWithCross == obj.completeDate){
                let time = (crossObject.time).trim()
                if(time == 'Todo el horario'){
                  if(!value2){
                    value2 = `El programa "${crossObject.newProgram}" ocupó todo su horario`
                  }
                  lastValue = value2
                  // arrItems[arrItems.length -1][ element ] = `El programa ${crossObject.newProgram} ocupó todo su horario`
                } else {
                  lastValue = value1
                  // arrItems[arrItems.length -1][ element ] = textToShow;
                }
              } else {
                lastValue = value1
                // arrItems[arrItems.length -1][ element ] = textToShow;
              }
            })
          }
        })
      } else{
        lastValue = value1
        // arrItems[arrItems.length -1][ element ] = textToShow;
      }

      return lastValue
    },
    // METODO PARA VALIDAR SI LOS CAPS TIENEN CORTES

    verifyCapsCuts (objChapter, cutsOfMaterial, allChapters, prop, text) {
      const notCuts = text
      let infoToShow = ''
      if (cutsOfMaterial.length > 0) {
        if (allChapters.length > 0 ) {
          let data = cutsOfMaterial
          let typeCut =  data.length > 0 &&  data[0].allChapters.cuts.length > 0 ? 'allChapters' : "ranger and caps"
          if (typeCut == 'allChapters' ) {
            let string = ''
            data[0].allChapters.cuts.map((el, i, arr) => {
              string += i !== arr.length -1 ? (el.duration).slice(3,5)  + ' min - ' : (el.duration).slice(3,5)  + ' min' 
            })
            this.durationCortes = string
          }
          
          let typeSubCut;
          switch(typeCut) {
            case 'allChapters':
              infoToShow = (typeof data[0].allChapters[prop] == 'string')?data[0].allChapters[prop]:data[0].allChapters[prop].length
              typeSubCut= 'allChapters'
            break;
            default:
              if(data[0]) {
                /*Por capítulos individuales y rangos*/
                if(data[0].individualChapters.length > 0 && data[0].chapterRanges.length > 0) {
                  let array = []
                  allChapters.map((chapter)=>{
                    let dataChapters = []
                    data[0].chapterRanges.map((object)=>{
                      if((object.startChapter <= chapter) && (object.finalChapter >= chapter)){
                        dataChapters = object[prop]
                      }
                    })
                     let string = ''
                    data[0].individualChapters.map((iChapter)=>{
                        
                      if(iChapter.chapter == chapter) {
                        dataChapters = iChapter[prop]
                      }
                    })

                    if(dataChapters.length > 0){
                      array.push(dataChapters)
                    } else {
                      array.push(notCuts)
                    }

                  })
                  
                  this.durationCortes  = ''
                  let string = ''
                  let dataByChap = []
                  array.map((chap, y, arr )=>{
                    if(chap == notCuts) {
                      dataByChap.push(chap)
                    } else {
                      if(typeof chap == 'string'){
                        dataByChap.push(chap)
                      } else {
                        string += ` <span class="text-ligth"> cap n° ${allChapters[y]}: </span>  &nbsp `
                        dataByChap.push(chap.length)
                        chap.map((el, i, arr) => {
                          string += i !== arr.length -1 ? (el.duration).slice(3,5)  + ' min - ' : (el.duration).slice(3,5)  + ' min' 
                        })
                        string += y !== arr.length -1 ?  ' <br> '   :  ''      
                      }
                    }
                  })
                  

                  this.durationCortes = string
                  infoToShow = dataByChap.join(' - ')
                  typeSubCut= 'rangerChaptersAndIndividual'

                /*Por capítulos individuales*/
                } else if(data[0].individualChapters.length > 0) {
                  let array = []
                  allChapters.map((chapter, indx)=> {
                    let dataChapters = []
                    let string = ''

                    if(chapter == '' && objChapter[indx].rolCodigoSelected){
                      chapter = 1
                    }

                    data[0].individualChapters.map((iChapter)=>{
                      if(iChapter.chapter == chapter){
                        dataChapters = iChapter[prop]
                      }
                    })

                    if(dataChapters.length > 0){
                      array.push(dataChapters)
                    } else {
                      array.push(notCuts)
                    }
                  })
                  let dataByChap = []
                  this.durationCortes  = ''
                  let string = ''
                  array.map((chap, y, arr) => {
                    if(chap == notCuts){
                      dataByChap.push(chap)
                    } else {
                      if(typeof chap == 'string'){
                        dataByChap.push(chap)
                      } else {
                        string += ` <span class="text-ligth"> cap n° ${allChapters[y]}: </span> &nbsp `
                        dataByChap.push(chap.length)
                        chap.map((el, i, arr) => {
                          string += i !== arr.length -1 ? (el.duration).slice(3,5)  + ' min - ' : (el.duration).slice(3,5)  + ' min' 
                        })
                        string += y !== arr.length -1 ?  '<br>':  ''                  
                      }
                    }
                  })
                  this.durationCortes = string
                  infoToShow = dataByChap.join(' - ')
                  typeSubCut= 'individualChapters'
                /*Por rangos*/
                } else if(data[0].chapterRanges.length > 0){
                  let array = []
                  allChapters.map((chapter)=>{
                    let dataChapters = []
                    data[0].chapterRanges.map((object)=>{
                      if((object.startChapter <= chapter) && (object.finalChapter >= chapter)){
                        dataChapters = object[prop]
                      }
                    })

                    if(dataChapters.length > 0){
                      array.push(dataChapters)
                    } else {
                      array.push(notCuts)
                    }
                  })

                  this.durationCortes  = ''
                  let string = ''
                  let dataByChap = []
                  array.map((chap, y, arr)=> {
                    if(chap == notCuts) {
                      dataByChap.push(chap)
                    } else {
                      if(typeof chap == 'string') {
                        dataByChap.push(chap)
                      } else {
                        string += `<span class="text-ligth"> cap n° ${allChapters[y]} :<span> &nbsp`
                        dataByChap.push(chap.length)
                        chap.map((el, i, arr) => {
                          string += i !== arr.length -1 ? (el.duration).slice(3,5)  + ' min - ' : (el.duration).slice(3,5)  + ' min' 
                        })
                        string += y !== arr.length -1 ?  '<br>':  ''  
                      }
                    }
                  })
                  this.durationCortes = string
                  infoToShow = dataByChap.join(' - ')
                  typeSubCut= 'rangerChapters'
                } else {
                  infoToShow = notCuts
                  typeSubCut= 'ninguno'
                }
              } 
            break;
          }      
        }
      }
      return infoToShow
    },
    dataGetter(programObject, arrWeekDates, gridInfo) {
      // console.log(programObject, 'programObject---22222----')
      let dayNames = ['Lunes', 'Martes', 'Miercoles', 'Jueves', 'Viernes', 'Sabado', 'Domingo'];
      let newArr = [];
      let newDates = [0,0,0,0,0,0,0];
      let insertGrid = [0,0,0,0,0,0,0];

      // ACA SE LLENA LA DATA DE LA TABLA
      // console.log("programObject", programObject);
      programObject.transmissionDays.map((el, i, arr) => {
        if(el === "Lunes") {
          newArr.push(arrWeekDates[0])
        } else if (el === "Martes") {
          newArr.push(arrWeekDates[1])
        } else if (el === "Miércoles") {
          newArr.push(arrWeekDates[2])
        } else if (el === "Jueves") {
          newArr.push(arrWeekDates[3])
        } else if (el === "Viernes") {
          newArr.push(arrWeekDates[4])
        } else if (el === "Sábado") {
          newArr.push(arrWeekDates[5])
        } else if (el === "Domingo") {
          newArr.push(arrWeekDates[6])
        }
      })
      
      // console.log("arrWeekDates", arrWeekDates);
      newArr.map((el, i, arr) => {
        if(el == arrWeekDates[0]) {
          newDates.splice(0, 1, el);
        } else if(el === arrWeekDates[1]) {
          newDates.splice(1, 1, el);
        } else if(el === arrWeekDates[2]) {
          newDates.splice(2, 1, el);
        } else if(el === arrWeekDates[3]) {
          newDates.splice(3, 1, el);
        } else if(el === arrWeekDates[4]) {
          newDates.splice(4, 1, el);
        } else if(el === arrWeekDates[5]) {
          newDates.splice(5, 1, el);
        } else if(el === arrWeekDates[6]) {
          newDates.splice(6, 1, el);
        }
      })
      newDates.map((el,i,arr) => {
        if(gridInfo.gridMatch && el !== 0) {
          gridInfo.gridMatch.map((element, index, array) => {
            if(element.dailyProgramDate === el) {
              element.programGridTitle = programObject.programTitle
              newDates.splice(i, 1, element);
              this.cardsData.splice(i, 1, newDates[i]);
            }  
          })
        }
      })
      // console.log(this.cardsData, 'this.cardsData---1')
      
      // GENERAR LAS FECHA COMPLETA DE LOS DIAS
      
      let daysWithFullDate = this.getFullDateOfTransmissionsDays()
      // console.log(daysWithFullDate, 'daysWithFullDate')
      for(let i=0; i<newDates.length; i++){
        if(typeof newDates[i] === 'string') {
          let newProgramObj = {
            chapters: [{
              numChapter: null,
              rerun: false,
              estreno: false,
              ongoing: false,
              season: "",
              seasonInfo: "",
              currencySymbolChap: "USD",
              priceByChap: null,
              priceByPass: null
            }],
            programGridTitle: programObject.programTitle,
            dailyProgramDate: "",
            completeDate: "",
            scheduleStartHour: programObject.scheduleStartHour,
            scheduleStartMin: programObject.scheduleStartMin,
            scheduleEndHour: programObject.scheduleEndHour,
            scheduleEndMin: programObject.scheduleEndMin,
            materialTitle: "",
            codMaterial: "",
            material: {},
            refProgram: programObject,
            isShowTemporadas: false,
            programDate: '',
            geminisCodeProgram: programObject.geminisCode
          }
          for(let m=0; m<daysWithFullDate.length; m++){
            let daySelect = daysWithFullDate[m].split(' ')[1]
            if(daySelect == newDates[i]){
              newProgramObj.completeDate = daysWithFullDate[m]
            }
          }
        // console.log(newProgramObj, 'newProgramObj_____')
          newDates.splice(i, 1, newProgramObj);
          this.cardsData.splice(i, 1, newDates[i]);
        }
      }
      // END
      this.arrByDays = newDates
      this.arrProgram = []
      
      if(this.arrByDays && this.arrByDays.length) {
        let items = ['Inicio', 'Final', 'Material', 'Capítulo', 'Estado', 'Tipo'];
        let arrItems = []
        let colItems = ['bFirstDayStart', 'cSecondDayStart', 'dthirdDayStart', 'eFourthDayStart', 'fFifthDayStart', 'gSixthDayStart', 'hLastDayStart'];
          
        let arrDaysOfWeek = [this.firstDayTable, this.secondDayTable, this.thirdDayTable, this.fourthDayTable, this.fifthDayTable, this.sixthDayTable, this.lastDayTable]

        
        items.map((el, i, arr) => {
          // console.log({el});
          arrItems.push({ aItems: el })
          // console.log({arrItems})
          colItems.map((element, index, array) => {
            let principalObject = this.arrByDays[index]
            let isMatExisting = this.arrByDays[index].materialExisting
            let isEmpty, textToShow 
            switch (el) {           
              case 'Inicio':
                isEmpty = this.arrByDays[index].scheduleStartHour === ''
                textToShow = calculateHour(this.arrByDays[index].scheduleStartHour) + ':' + calculateHour(this.arrByDays[index].scheduleStartMin)
                this.verifyProgramCrossover(principalObject, isEmpty, arrItems, element, textToShow)
              break;
              case 'Final':
                isEmpty = this.arrByDays[index].scheduleEndHour === ''
                textToShow = calculateHour(this.arrByDays[index].scheduleEndHour) + ':' + calculateHour(this.arrByDays[index].scheduleEndMin)
                this.verifyProgramCrossover(principalObject, isEmpty, arrItems, element, textToShow)
              break;
              case 'Capítulo':
                let chapArr = []
                let chaptersString = ''
                isEmpty = (this.arrByDays[index].chapters == undefined)
                if(!isEmpty){
                  this.arrByDays[index].chapters.map((el,i,arr) => {
                    chapArr.push(el.numChapter);
                  })
                  chaptersString = chapArr.join(' - ');
                }
                
                textToShow = chaptersString
                this.verifyProgramCrossover(principalObject, isEmpty, arrItems, element, textToShow)
              break;
              case 'Material':   
              let prueba = this.arrByDays[index]
                if (principalObject !== 0) {
                  textToShow = this.arrByDays[index].materialTitle
                }
                else {
                  textToShow = ''
                }  
             
                this.verifyProgramCrossover(principalObject, isEmpty, arrItems, element, textToShow)
              break;
              case 'Estado':
                let stateArr = []
                let stateString = ''
                isEmpty = (this.arrByDays[index].chapters == undefined)
                if(!isEmpty){
                  this.arrByDays[index].chapters.map((el,i,arr) => {
                    let statusChapter = []
                    if(el.rerun){
                      statusChapter.push('Rerun')
                    }
                    if(el.estreno){
                      statusChapter.push('Estreno')
                    }
                    if(el.ongoing){
                      statusChapter.push('Ongoing')
                    }
                    
                    let stateFinal = statusChapter.join(' - ')
                    stateArr.push(stateFinal)
                  })
                  stateString = stateArr.join(' / ')
                }

                textToShow = stateString
                this.verifyProgramCrossover(principalObject, isEmpty, arrItems, element, textToShow)
              break;
              case 'N° de Cortes':
                let allChapters = []
                let cutsOfMaterial= []
                
                if(principalObject !== 0){
                  if(this.arrByDays[index].dailyCuttingProgram !== undefined){
                    cutsOfMaterial = this.arrByDays[index].dailyCuttingProgram
                  } else {
                    cutsOfMaterial = []
                  }
                } else {
                  cutsOfMaterial = []
                }
                
                isEmpty = (this.arrByDays[index].chapters == undefined)
                if(!isEmpty) {
                  this.arrByDays[index].chapters.map((el,i,arr) => {
                    allChapters.push(el.numChapter);
                  })
                }

                const text = 'Sin Cortes'
                textToShow = this.verifyCapsCuts(this.arrByDays[index].chapters, cutsOfMaterial, allChapters, 'cuts', text)
                this.verifyProgramCrossover(principalObject, isEmpty, arrItems, element, textToShow)
              break;
              case 'Duración Artística':
                let chaptersOfDay = []
                let cutsMaterial= []
                if(principalObject !== 0){
                  if(this.arrByDays[index].dailyCuttingProgram !== undefined){
                    cutsMaterial = this.arrByDays[index].dailyCuttingProgram
                  } else {
                    cutsMaterial = []
                  }
                } else {
                  cutsMaterial = []
                }

                isEmpty = (this.arrByDays[index].chapters == undefined)
                if(!isEmpty){
                  this.arrByDays[index].chapters.map((el,i,arr) => {
                    chaptersOfDay.push(el.numChapter);
                  })
                }
                const noShow = '-'
                textToShow = this.verifyCapsCuts(this.arrByDays[index].chapters, cutsMaterial, chaptersOfDay, 'artisticDuration', noShow)
                this.verifyProgramCrossover(principalObject, isEmpty, arrItems, element, textToShow)
                
              break;
              case 'Clasificación':
                isEmpty = (this.arrByDays[index].artisticDuration !== undefined)
                if(principalObject !== 0){
                  if(this.arrByDays[index].material.classification !== undefined){
                    textToShow = this.arrByDays[index].material.classification
                  } else {
                    textToShow = ''
                  }
                } else {
                  textToShow = ''
                }
                
                this.verifyProgramCrossover(principalObject, isEmpty, arrItems, element, textToShow)
              break;
              case 'Género':
                isEmpty = (this.arrByDays[index].artisticDuration !== undefined)
                if(principalObject !== 0){
                  if(this.arrByDays[index].material.genre !== undefined){
                    textToShow = this.arrByDays[index].material.genre
                  } else {
                    textToShow = ''
                  }
                } else {
                  textToShow = ''
                }
                
                this.verifyProgramCrossover(principalObject, isEmpty, arrItems, element, textToShow)
              break;
              case 'Tipo':
                if (principalObject !== 0) {
                  textToShow = this.arrByDays[index].typeOfContent ? this.arrByDays[index].typeOfContent : ''
                }
                else {
                  textToShow = ''
                }  
                
                this.verifyProgramCrossover(principalObject, isEmpty, arrItems, element, textToShow)
              break;
              case 'Señales':
                isEmpty = (this.arrByDays[index].artisticDuration !== undefined)
                if(principalObject !== 0){
                  if(this.arrByDays[index].refProgram.checkedSignalsDescription !== undefined){
                    textToShow = this.arrByDays[index].refProgram.checkedSignalsDescription
                  } else {
                    textToShow = ''
                  }
                } else {
                  textToShow = ''
                }
                
                this.verifyProgramCrossover(principalObject, isEmpty, arrItems, element, textToShow)
              break;
              default: 
                arrItems[arrItems.length -1][ element ] = '';
            }
          })
        })
        this.arrProgram = arrItems
      }  
    },
    async querySearch (queryString, cb) {
      const channel = localStorage.getItem('channelTransmition');
      let response = await HTTP.post('programs/filterProgram',{channel,title:queryString})
      if(response.data.docs.length==0) return;
      cb(response.data.docs)
    },
    handleSelect (item) {
      this.programObj = item
      this.codeProgramSelected = item.codProgram
      this.durationCortes = ''
      this.filterWeek()
    },
    programObjectInfo (routeName, gridInfo) {      
      
      let arrTransmissionDays = this.programObj.transmissionDays
      let day
 

      for (var i = 0; i < arrTransmissionDays.length; i++) {
        switch (modifyText(arrTransmissionDays[i])) {
         case 'lunes':
            day = this.firstDayOfWeek
            break;
          case 'martes':
            day = moment(this.firstDayOfWeek).add(1, 'days')._d
            break;
          case 'miercoles':
             day = moment(this.firstDayOfWeek).add(2, 'days')._d
            break;
          case 'jueves':
             day = moment(this.firstDayOfWeek).add(3, 'days')._d
            break;
          case 'viernes':
            day = moment(this.firstDayOfWeek).add(4, 'days')._d
            break;
          case 'sabado':
            day = moment(this.firstDayOfWeek).add(5, 'days')._d
            break;
          case 'domingo':
            day = moment(this.firstDayOfWeek).add(6, 'days')._d
            break;
        }

        let dateTime = moment(day)
        let dd = convertFirstWordTouperCase(dateTime.format('dddd'))
        let numberOfDay = Number(dateTime.format('D'))
        let month = convertFirstWordTouperCase(dateTime.format('MMMM'))
        let year = dateTime.format('YYYY')

        let date = {
          programDate: dateTime._d,
          day: dd, 
          numberOfDay: numberOfDay,
          month: month,
          year: year,
          monthNumber: months.indexOf(months[day.getMonth()]) + 1
        }

        let dateSentence = `${ dd } ${ numberOfDay } de ${ month} del ${ year }`
        this.arrOfDays.push(date)
        this.completeDateArr.push(dateSentence);
      }
      // console.log("this.programObj", this.programObj);
      let payload = {
        dataSentence: this.completeDateArr,
        programInfo: this.programObj,
        grid: gridInfo,
        dateString: this.dateString,
        day: this.firstDay,
        month: this.firstDayOfWeek.getMonth(),
        year: this.year,
        cardsData: this.cardsData,
        arrOfDays: this.arrOfDays,
        codMaterial: gridInfo.gridMatch && gridInfo.gridMatch.length !== 0 ? null : null,
        codProgram: this.codeProgramSelected,
        dateStart: this.startDate,
        dateEnd: this.endDate,
      }
      
      console.log(this.dateSearch, 'dateSearch---')
      console.log(payload, 'payload')
      this.$localStorage.set('gridPayload', JSON.stringify(payload))
      this.$store.dispatch('sendProgramObj', payload)
      this.$router.push({name: routeName, params: {type: this.typeChannel, day: this.dateSearch}})
      // , day: 
    },
    async isWeekAproved(){
      this.gridData = null
      this.noEsVigente = true
      let response = await HTTP.post('grid/filterWeek',{week:this.dateString})
      const responseData = response.data.ok? response.data.grid : null;
      this.gridData = responseData
      if(responseData) this.isWeekAprovedFlag = responseData.approvedWeek
      else this.isWeekAprovedFlag = false
      this.noEsVigente = false
    }
  },
  watch: {
    programObj(){
      sessionStorage.setItem('programa-parrilla-peliminar',JSON.stringify(this.programObj));
      console.log(this.programObj, 'this.programObj-----------')
    },
		arrProgram:{
			handler(newVal, oldVal){
				if(newVal !== ''){
          this.fillingProgramTable(newVal)
        }
			},
			// immediate: true
    },
    objGridInfo(val) {
      if(this.dateString != '' && this.codeProgramSelected != '') {
        this.getWeekDays()
      }
    },
    getDataWeek: {
      handler(newVal, oldVal){
        if(newVal !== oldVal){
          this.getWeekDays()
        }
      }
    },
	}
}
</script>

<style>
/* GRILLA DE LOS DIAS */
.scheduleProgramming {
  display: grid;
  grid-template-columns: repeat(8, 152.1px);
  align-items: center;
  border: 2px #828282 solid;
}

.scheduleDay {
  background: #ff7333;
  color: white;
  font-weight: 500;
  font-size: 18px;
  text-align: center;
  text-transform: uppercase;
  padding: 8px 0;
}
.scheduleDay-border {
  border-right: 2px #828282 solid;
}
/* GRILLA DE LA DATA */
.scheduleData {
  display: grid;
  grid-template-columns: repeat(8, 152.1px);
  grid-template-rows: repeat(6, minmax(55px, max-content));
  border: 2px #828282 solid;
  border-top: 0;
  background: #e0e0e0;
}
.schedule__border-right {
  border-right: 2px #828282 solid;
}
.scheduleCellData__border-bottom {
  border-bottom: 1px #828282 solid;
}
.scheduleCellData__border-top {
  border-top: 1px #828282 solid;
}
/* ESTILOS DE LOS DIVS DE LA DATA */
.newDiv {
  background: white;
  border-right: 2px solid #828282;
  border-bottom: 1px solid #828282;
  border-top: 1px solid #828282;
  text-align: center;
  display: flex;
  justify-content: center;
  align-items: center;
}
.border-r-0 {
  border-right: 0;
}
.border-b-0 {
  border-bottom: 0;
}
.redText {
  color: red;
  font-size: 12px;
  font-weight: 500;
  padding: 5px;
}

.tooltip {
  position: relative;
  display: inline-block;
  border-bottom: 1px dotted black;
}

.tooltip .tooltiptext {
  visibility: hidden;
  width: 350px;
  /* background-color: #555;
  color: #fff; */
  text-align: center;
  /* border-radius: 6px; */
  padding: 5px 0;
  position: absolute;
  z-index: 1;
  bottom: 125%;
  left: 50%;
  margin-left: -60px;
  opacity: 0;
  transition: opacity 0.3s;
  background: #fafafa;
  box-shadow: 0px 19px 38px rgba(0, 0, 0, 0.3),
    0px 15px 12px rgba(0, 0, 0, 0.22);
  border-radius: 2px;
}

.tooltip .tooltiptext::after {
  content: '';
  position: absolute;
  top: 100%;
  left: 50%;
  margin-left: -5px;
  border-width: 5px;
  border-style: solid;
  border-color: #555 transparent transparent transparent;
}

.tooltip:hover .tooltiptext {
  visibility: visible;
  opacity: 1;
}
</style>